# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a file hash entity.
    #
    class FileHashEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "FileHash"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [FileHashAlgorithm] The hash algorithm type. Possible values
      # include: 'Unknown', 'MD5', 'SHA1', 'SHA256', 'SHA256AC'
      attr_accessor :algorithm

      # @return [String] The file hash value.
      attr_accessor :hash_value


      #
      # Mapper for FileHashEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'FileHash',
          type: {
            name: 'Composite',
            class_name: 'FileHashEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              algorithm: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.algorithm',
                type: {
                  name: 'String'
                }
              },
              hash_value: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hashValue',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
