# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents an IoT device entity.
    #
    class IoTDeviceEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "IoTDevice"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The ID of the IoT Device in the IoT Hub
      attr_accessor :device_id

      # @return The ID of the security agent running on the device
      attr_accessor :iot_security_agent_id

      # @return [String] The type of the device
      attr_accessor :device_type

      # @return [String] The vendor of the device
      attr_accessor :vendor

      # @return [String] The ID of the edge device
      attr_accessor :edge_id

      # @return [String] The AzureResource entity id of the IoT Hub
      attr_accessor :iot_hub_entity_id

      # @return [String] The Host entity id of this device
      attr_accessor :host_entity_id

      # @return [Array<ThreatIntelligence>] A list of TI contexts attached to
      # the IoTDevice entity.
      attr_accessor :threat_intelligence


      #
      # Mapper for IoTDeviceEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'IoTDevice',
          type: {
            name: 'Composite',
            class_name: 'IoTDeviceEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              device_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.deviceId',
                type: {
                  name: 'String'
                }
              },
              iot_security_agent_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.iotSecurityAgentId',
                type: {
                  name: 'String'
                }
              },
              device_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.deviceType',
                type: {
                  name: 'String'
                }
              },
              vendor: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.vendor',
                type: {
                  name: 'String'
                }
              },
              edge_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.edgeId',
                type: {
                  name: 'String'
                }
              },
              iot_hub_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.iotHubEntityId',
                type: {
                  name: 'String'
                }
              },
              host_entity_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.hostEntityId',
                type: {
                  name: 'String'
                }
              },
              threat_intelligence: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.threatIntelligence',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ThreatIntelligenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ThreatIntelligence'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
