# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents an ip entity.
    #
    class IpEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "Ip"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The IP address as string, e.g. 127.0.0.1 (either in
      # Ipv4 or Ipv6)
      attr_accessor :address

      # @return [GeoLocation] The geo-location context attached to the ip
      # entity
      attr_accessor :location

      # @return [Array<ThreatIntelligence>] A list of TI contexts attached to
      # the ip entity.
      attr_accessor :threat_intelligence


      #
      # Mapper for IpEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Ip',
          type: {
            name: 'Composite',
            class_name: 'IpEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              address: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.address',
                type: {
                  name: 'String'
                }
              },
              location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.location',
                type: {
                  name: 'Composite',
                  class_name: 'GeoLocation'
                }
              },
              threat_intelligence: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.threatIntelligence',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ThreatIntelligenceElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ThreatIntelligence'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
