# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Threat intelligence indicator entity.
    #
    class ThreatIntelligenceIndicatorWithoutReadOnlyFields < ThreatIntelligenceResourceKind1

      include MsRestAzure

      # @return [String] Etag of the azure resource
      attr_accessor :etag

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [Array<String>] List of tags
      attr_accessor :threat_intelligence_tags

      # @return [String] Last updated time in UTC
      attr_accessor :last_updated_time_utc

      # @return [String] Source of a threat intelligence entity
      attr_accessor :source

      # @return [String] Display name of a threat intelligence entity
      attr_accessor :display_name

      # @return [String] Description of a threat intelligence entity
      attr_accessor :description

      # @return [Array<String>] Indicator types of threat intelligence entities
      attr_accessor :indicator_types

      # @return [String] Pattern of a threat intelligence entity
      attr_accessor :pattern

      # @return [String] Pattern type of a threat intelligence entity
      attr_accessor :pattern_type

      # @return [Array<ThreatIntelligenceKillChainPhase>] Kill chain phases
      attr_accessor :kill_chain_phases

      # @return [String] External ID of threat intelligence entity
      attr_accessor :external_id

      # @return [String] Created by reference of threat intelligence entity
      attr_accessor :created_by_ref

      # @return [Array<String>] External References
      attr_accessor :external_references

      # @return [Array<ThreatIntelligenceGranularMarkingModel>] Granular
      # Markings
      attr_accessor :granular_markings

      # @return [Boolean] Is threat intelligence entity revoked
      attr_accessor :revoked

      # @return [Integer] Confidence of threat intelligence entity
      attr_accessor :confidence

      # @return [Array<String>] Labels  of threat intelligence entity
      attr_accessor :labels

      # @return [Array<String>] Threat types
      attr_accessor :threat_types

      # @return [String] Valid from
      attr_accessor :valid_from

      # @return [String] Valid until
      attr_accessor :valid_until

      # @return [String] Created by
      attr_accessor :created

      # @return [String] Modified by
      attr_accessor :modified


      #
      # Mapper for ThreatIntelligenceIndicatorWithoutReadOnlyFields class as
      # Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'indicator',
          type: {
            name: 'Composite',
            class_name: 'ThreatIntelligenceIndicatorWithoutReadOnlyFields',
            model_properties: {
              kind: {
                client_side_validation: true,
                required: true,
                is_constant: true,
                serialized_name: 'kind',
                default_value: 'indicator',
                type: {
                  name: 'String'
                }
              },
              etag: {
                client_side_validation: true,
                required: false,
                serialized_name: 'etag',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              threat_intelligence_tags: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.threatIntelligenceTags',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              last_updated_time_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.lastUpdatedTimeUtc',
                type: {
                  name: 'String'
                }
              },
              source: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.source',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.displayName',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              indicator_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.indicatorTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              pattern: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.pattern',
                type: {
                  name: 'String'
                }
              },
              pattern_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.patternType',
                type: {
                  name: 'String'
                }
              },
              kill_chain_phases: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.killChainPhases',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ThreatIntelligenceKillChainPhaseElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ThreatIntelligenceKillChainPhase'
                      }
                  }
                }
              },
              external_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.externalId',
                type: {
                  name: 'String'
                }
              },
              created_by_ref: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.createdByRef',
                type: {
                  name: 'String'
                }
              },
              external_references: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.externalReferences',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              granular_markings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.granularMarkings',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ThreatIntelligenceGranularMarkingModelElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ThreatIntelligenceGranularMarkingModel'
                      }
                  }
                }
              },
              revoked: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.revoked',
                type: {
                  name: 'Boolean'
                }
              },
              confidence: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.confidence',
                type: {
                  name: 'Number'
                }
              },
              labels: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.labels',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              threat_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.threatTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              valid_from: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.validFrom',
                type: {
                  name: 'String'
                }
              },
              valid_until: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.validUntil',
                type: {
                  name: 'String'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.created',
                type: {
                  name: 'String'
                }
              },
              modified: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.modified',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
