# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::SecurityInsights::Mgmt::V2019_01_01_preview
  module Models
    #
    # Represents a malware entity.
    #
    class MalwareEntity < Entity

      include MsRestAzure


      def initialize
        @kind = "Malware"
      end

      attr_accessor :kind

      # @return A bag of custom fields that should be part of the entity and
      # will be presented to the user.
      attr_accessor :additional_data

      # @return [String] The graph item display name which is a short humanly
      # readable description of the graph item instance. This property is
      # optional and might be system generated.
      attr_accessor :friendly_name

      # @return [String] The malware category by the vendor, e.g. Trojan
      attr_accessor :category

      # @return [Array<String>] List of linked file entity identifiers on which
      # the malware was found
      attr_accessor :file_entity_ids

      # @return [String] The malware name by the vendor, e.g. Win32/Toga!rfn
      attr_accessor :malware_name

      # @return [Array<String>] List of linked process entity identifiers on
      # which the malware was found.
      attr_accessor :process_entity_ids


      #
      # Mapper for MalwareEntity class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Malware',
          type: {
            name: 'Composite',
            class_name: 'MalwareEntity',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'kind',
                type: {
                  name: 'String'
                }
              },
              additional_data: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.additionalData',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ObjectElementType',
                      type: {
                        name: 'Object'
                      }
                  }
                }
              },
              friendly_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.friendlyName',
                type: {
                  name: 'String'
                }
              },
              category: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.category',
                type: {
                  name: 'String'
                }
              },
              file_entity_ids: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.fileEntityIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              malware_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.malwareName',
                type: {
                  name: 'String'
                }
              },
              process_entity_ids: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.processEntityIds',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
